import { styled } from "solid-styled-components";
import { vector2d } from "../../vector";
import { createSignal, onCleanup, onMount } from "solid-js";
import { getFacingAngle } from "../raycast";
import { useTimer } from "../../providers/timer";

export default function Attacker(props: {
  size?: number;
  speed?: number;
  damage?: number;
  position?: vector2d;
}) {
  const width = props.size ? props.size / 6 : 2;
  const height = props.size ?? 20;

  // Just some random comment
  // https://youtube.com/ishowspeed
  //
  // But I promise
  // Attackers' speed will slower than player(4u)
  let speed = props.speed ?? 2;

  let damage = props.damage ?? 8;

  // Position & Movement

  const [x, setX] = createSignal(
    props.position?.x ? props.position?.x - width / 2 : 0
  );
  const [y, setY] = createSignal(
    props.position?.y ? props.position?.y - height / 2 : 0
  );

  // Those code below are copied from player.tsx
  // I don't know why I didn't make a base class to impl the movement
  // We are using the function so that we cannot use the extend keyword
  // Howdy!
  let velocity = new vector2d(0, 0);

  function move() {
    setX((x) => (x += velocity.x));
    setY((y) => (y += velocity.y));
  }

  // These two variables should be the "Renderer" part
  // But we need use them to calculate the movement
  // So whatever
  //
  // It just works —— Mr. Todd
  let element: any;
  let target: any;

  function calcTrackingVelocity() {
    let rectSource = element.getBoundingClientRect();
    let rectTarget = target.getBoundingClientRect();
    // If we are higher than target, then move down
    if (rectSource.top < rectTarget.top) velocity.y = speed;
    // If we are lower than target, then move up
    else velocity.y = -speed;
    // etc...
    if (rectSource.left < rectTarget.left) velocity.x = speed;
    // etc...
    else velocity.x = -speed;
    // I really don't know what is the relationship between them.
    // But it just works.
    //
    // We use inline if and else to save more space to write those useless comments...
  }

  // Every tick move a little bit
  const [{ subscribe }] = useTimer();
  subscribe(() => {
    if (element && target) {
      calcTrackingVelocity();
    }
  });

  onMount(() => {
    const loop = setInterval(() => move(), 10);
    onCleanup(() => clearInterval(loop));
  });

  // Renderer

  const [facingAngle, setFacingAngle] = createSignal(0);

  function calcFacing() {
    target = document.querySelector<HTMLElement>(".crystal");
    if (element && target) {
      setFacingAngle(getFacingAngle(element, target) + 90);
    }
  }

  subscribe(() => calcFacing());

  const RequestElement = styled("svg")`
    width: ${width.toString()}px;
    height: ${height.toString()}px;

    transform: rotate(${facingAngle}deg);

    transition-property: transform;
    transition-timing-function: linear;
    transition-duration: 150ms;

    position: absolute;
  `;

  return (
    <RequestElement
      ref={element}
      class="hostile attackers"
      style={{ left: `${x()}px`, top: `${y()}px` }}
      data-damage={damage}
    >
      <rect width={width} height={height} fill="#a71c1c" />
    </RequestElement>
  );
}
