export function getFacingAngle(
  source: HTMLElement,
  target: HTMLElement
): number {
  let rectSource = source.getBoundingClientRect();
  let rectTarget = target.getBoundingClientRect();
  const deltaX = rectTarget.left - rectSource.left;
  const deltaY = rectTarget.top - rectSource.top;
  const angleInDegrees = Math.atan2(deltaY, deltaX) * (180 / Math.PI);
  return angleInDegrees;
}
